
/**
 * Trida predstavuje osobu. Pro jednoduchost jsou dve osoby stejne, pokud 
 * maji stejne jmeno.
 * 
 * @author Ales Zlamal
 * @author Radek Oslejsek
 * @version 2008-01-18
 */
public class Person
{
    private String name;

    /**
     * @param name Jmeno osoby
     * @throws NullPointerException pokud je jmeno null
     * @throws IllegalArgumentException pokud jmeno obsahuje jen bile znaky
     */
    public Person(String name) {
        if (name == null) throw new NullPointerException("name");
        if (name.trim().isEmpty()) throw new IllegalArgumentException("name");
        this.name = name;
    }
    
    /**
     * @return jmeno
     */
    public String getName() {
        return name;
    }
    
    /**
     * @return true pokud maji dve osoby stejne jmeno, jinak false
     */
    public boolean equals(Object obj) {
        if (obj == this) return true;
        return ((obj instanceof Person) && 
                ((Person)obj).name.toLowerCase().equals(name.toLowerCase()));
    }
    
    public int hashCode() {
        return name.hashCode();
    }
    
    public String toString() {
        return name;
    }
}
