import java.io.*;
import java.util.*;

/**
 * The test class TestTown.
 *
 * @author  (your name)
 * @version (a version number or a date)
 */
public class TestTownStorage extends junit.framework.TestCase
{
    private TownStorage ts;
    
    private Person[] persons = new Person[] {
        new Person("Marek"),
        new Person("Adam"),
        new Person("Eva"),
        new Person("Renata"),
        new Person("David"),
        new Person("Zuzana")
    };
    
    private Town[] towns = new Town[] {
        new Town("Lucca"),
        new Town("Parma"),
        new Town("Perugia"),
        new Town("Piacenza"),
        new Town("Livorno"),
        new Town("Siena"),
        new Town("Ravenna"),
        new Town("Ferrara"),
        new Town("Mantua"),
        new Town("Padua"),
        new Town("Pisa"),
        new Town("Bologna"),
        new Town("Urbino"),
        new Town("Arezzo"),
        new Town("Firenze"),
        new Town("Roma"),
        new Town("San Gimignano"),
        new Town("Orvieto")
    };
    
    
    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    protected void setUp()
    {
        ts = new TownStorageImpl();
        
    }
    
    public void testRead() {
        try {
            ts.read(null);
            fail("Metoda read(null) nevyhodila pozadovanou vyjimku");
        } catch (NullPointerException ex) {
        } catch (Exception ex) {
            fail ("Metoda read(null) vyhodila spatnou vyjimku " + ex);
        }
        
        try {
            ts.read("dsads");
            fail("Metoda read() nevyhodila pozadovanou vyjimku pro neexistujici soubor");
        } catch (TownException ex) {
        } catch (Exception ex) {
            fail ("Metoda read() vyhodila spatnou vyjimku pro neexistujici soubor" + ex);
        }

        Map<Person,Set<Town>> m1 = null;
        try {
            m1 = ts.read("input.txt");
        } catch (Exception ex) {
            fail ("Metoda read() vyhodila vyjimku pri nacitani spravneho souboru: " + ex);
        }
        
        Set<Town> allTowns = new HashSet<Town>();
        assertNotNull("Metoda read() vratila null pri cteni spravneho souboru", m1);
        for (Person p: persons) {
            assertTrue("Mapa vracena metodou read() neobsahuje navrhovatele " + p.getName(), m1.containsKey(p));
            allTowns.addAll(m1.get(p));
        }
        for (Town t: towns) {
            assertTrue("Mapa vracena metodou read() neobsahuje mesto " + t.getName(), allTowns.contains(t));
        }
        
        assertEquals("Mapa vracena metodou read() ma spatny pocet mest u navrhovatele " + persons[0],7,m1.get(persons[0]).size());
        assertEquals("Mapa vracena metodou read() ma spatny pocet mest u navrhovatele " + persons[1],6,m1.get(persons[1]).size());
        assertEquals("Mapa vracena metodou read() ma spatny pocet mest u navrhovatele " + persons[2],5,m1.get(persons[2]).size());
        assertEquals("Mapa vracena metodou read() ma spatny pocet mest u navrhovatele " + persons[3],7,m1.get(persons[3]).size());
        assertEquals("Mapa vracena metodou read() ma spatny pocet mest u navrhovatele " + persons[4],5,m1.get(persons[4]).size());
        assertEquals("Mapa vracena metodou read() ma spatny pocet mest u navrhovatele " + persons[5],6,m1.get(persons[5]).size());
    }
    
    public void testProposalsOfTowns() {
        
        try {
            ts.proposalsOfTowns(null);
            fail("Metoda proposalsOfTowns(null) nevyhazuje pozadovanou vyjimku");
        } catch (NullPointerException ex) {        
        } catch (Exception ex) {
            fail("Metoda proposalsOfTowns(null) nevyhazuje spatnou vyjimku");
        }       
        
        Map<Town, Set<Person>> m = null;
        try {
            m = ts.proposalsOfTowns(ts.read("input.txt"));
        } catch (TownException ex) {
            ex.printStackTrace();
            fail();
        }

        Set<Person> allPersons = new HashSet<Person>();
        assertNotNull("Metoda proposalsOfTowns() vratila null", m);
        for (Town t: towns) {
            assertTrue("Mapa vracena metodou proposalsOfTowns() neobsahuje mesto " + t.getName(), m.containsKey(t));
            allPersons.addAll(m.get(t));
        }
        for (Person p: persons) {
            assertTrue("Mapa vracena metodou proposalsOfTowns() neobsahuje navrhovatele " + p.getName(), allPersons.contains(p));
        }
        
        assertEquals("Mapa vracena metodou proposalsOfTowns() ma spatny pocet navrhovatelu u mesta " + towns[0],2,m.get(towns[0]).size());
        assertEquals("Mapa vracena metodou proposalsOfTowns() ma spatny pocet navrhovatelu u mesta " + towns[1],1,m.get(towns[1]).size());
        assertEquals("Mapa vracena metodou proposalsOfTowns() ma spatny pocet navrhovatelu u mesta " + towns[2],1,m.get(towns[2]).size());
        assertEquals("Mapa vracena metodou proposalsOfTowns() ma spatny pocet navrhovatelu u mesta " + towns[3],2,m.get(towns[3]).size());
        assertEquals("Mapa vracena metodou proposalsOfTowns() ma spatny pocet navrhovatelu u mesta " + towns[4],1,m.get(towns[4]).size());
        assertEquals("Mapa vracena metodou proposalsOfTowns() ma spatny pocet navrhovatelu u mesta " + towns[17],2,m.get(towns[17]).size());
    }
    
    public void testWrite() {
        Map<Town, Set<Person>> m = null;
        try {
            m = ts.proposalsOfTowns(ts.read("input.txt"));
        } catch (TownException ex) {
            ex.printStackTrace();
            fail();
        }
        
        try {
            ts.write(null, "output.txt");
            fail("Metoda write(null, soubor) nevyhodila pozadovanou vyjimku");
        } catch (NullPointerException ex) {
        } catch (Exception ex) {
            fail ("Metoda write(null, soubor) vyhodila spatnou vyjimku " + ex);
        }
        
        try {
            ts.write(m, null);
            fail("Metoda write(mapa, null) nevyhodila pozadovanou vyjimku");
        } catch (NullPointerException ex) {
        } catch (Exception ex) {
            fail ("Metoda write(mapa, null) vyhodila spatnou vyjimku " + ex);
        }

        try {
            ts.write(m, "output.txt");
        } catch (Exception ex) {
            fail ("Metoda write() vyhodila neocekavanou vyjimku pri zapisu do souboru: " + ex);
        }
    }
}
