import java.util.Set;
import java.util.HashSet;
import java.util.Iterator;

/**
 * Trida predstavuje mesto. Pro jednoduchost jsou dve mesta stejna, pokud 
 * maji stejne jmeno.
 * 
 * @author Ales Zlamal
 * @author Radek Oslejsek
 * @version 2008-01-18
 */
public class Town{

    private String name;

    /**
     * Constructor for objects of class Town
     * 
     * @param nameOfTown je nazev mesta
     * @throws NullPointerException pokud je jmeno null
     * @throws IllegalArgumentException pokud jmeno obsahuje jen bile znaky
     */
    public Town(String nameOfTown){
        if (nameOfTown == null) throw new NullPointerException("nameOfTown");
        if (nameOfTown.trim().isEmpty()) throw new IllegalArgumentException("nameOfTown");
        this.name = nameOfTown;
    }

    /**
     * @return jmeno mesta
     */
    public String getName() {
        return name;
    }
    
    /**
     * @return true pokud maji obe mesta stejne jmeno, jinak false
     */
    public boolean equals(Object obj){
        if (obj == this) return true;
        return ((obj instanceof Town) && 
                ((Town)obj).name.toLowerCase().equals(name.toLowerCase()));
    }

    public int hashCode()   {
        return name.hashCode();
    }
    
    public String toString() {
        return name;
    }
}
